declare("runlua", runlua or {})

runlua.dialog = {}

local function createRunDialog()
	
	local scriptpad = iup.multiline {
		EXPAND = "YES",
		BGCOLOR = "0 0 0 100 *",
		SIZE = HUDSize(0.5, 0.75),
	}
	
	local RunLuaDialog = iup.dialog {
		topmost = "YES",
		title = "Vendetta Online Lua Assistant",
		iup.stationsubframe {
			iup.hbox {
				scriptpad,
				iup.vbox {
					iup.stationbutton {
						title = "Run script",
						action = function()
							loadstring(scriptpad.value)()
						end,
						expand = "HORIZONTAL",
					},
					iup.stationbutton {
						title = "Clear",
						action = function()
							scriptpad.value = ""
						end,
						expand = "HORIZONTAL",
					},
					iup.stationbutton {
						title = "Save",
						action = function()
							SaveSystemNotes(scriptpad.value, 4002300)
						end,
						expand = "HORIZONTAL",
					},
					iup.stationbutton {
						title = "Load",
						action = function()
							scriptpad.value = LoadSystemNotes(4002300)
						end,
						expand = "HORIZONTAL",
					},
					iup.stationbutton {
						title = "Reload",
						action = function()
							ReloadInterface()
						end,
						expand = "HORIZONTAL",
					},
				},
			},
		},
	}
	
	runlua.dialog = RunLuaDialog --eventually I need to stop being lazy and change this
	
end

local function execOrShowDialog(_, args)
	if (type(args) == "table") and args ~= {} then
		local argString = ""
		for key, value in pairs(args) do
			argString = argString .. " " .. value
		end
		loadstring(argString)()
	else
		ShowDialog(runlua.dialog)
	end
end

RegisterUserCommand("runlua", execOrShowDialog)

local optionsAccessButton = iup.stationsubframe {
	iup.vbox {
		iup.stationbutton {
			title = "Open lua multiline executor",
			action = function(self)
				execOrShowDialog()
			end,
		},
		iup.label {
			title = "\12751B9E2Run\12700FF00Lua \12751B9E2v2.0",
		},
	},
	cx = 0,
	cy = 0,
}

iup.Append(OptionsDialog[1][1], optionsAccessButton)

createRunDialog()